diff --git a/fw/hpack.c b/fw/hpack.c
index 60e9099dd..49256c149 100644
--- a/fw/hpack.c
+++ b/fw/hpack.c
@@ -4003,14 +4003,12 @@ tfw_hpack_set_rbuf_size(TfwHPackETbl *__restrict tbl, unsigned short new_size)
 	       " new_size=%hu\n", __func__, tbl->rb_len, tbl->size,
 	       tbl->window, new_size);
 
-	if (tbl->window > new_size) {
-		if (tbl->size > new_size)
-			tfw_hpack_rbuf_calc(tbl, new_size, NULL,
-					    (TfwHPackETblIter *)tbl);
-		WARN_ON_ONCE(tbl->rb_len > tbl->size);
+	if (tbl->size > new_size)
+		tfw_hpack_rbuf_calc(tbl, new_size, NULL,
+				    (TfwHPackETblIter *)tbl);
+	WARN_ON_ONCE(tbl->rb_len > tbl->size);
 
-		tbl->window = new_size;
-	}
+	tbl->window = new_size;
 
 	spin_unlock(&tbl->lock);
 }
